"use strict";
/**
 * Test documentation.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var child_process = require("child_process");
var chai_1 = require("chai");
var Databench = require(".");
var request = require("request");
describe('Standalone Process', function () {
    var databench_process_return_code = -42;
    var databench_process = child_process.spawn('python', [
        'databench/tests/standalone/test_standalone.py',
        '--log', 'WARNING',
        '--coverage', '.coverage.js.standalone',
        '--port', '5002',
        '--ssl-port', '5003',
        '--some-test-flag',
    ]);
    databench_process.stdout.on('data', function (data) { return console.log('databench stdout: ' + data); });
    databench_process.stderr.on('data', function (data) { return console.log('databench stderr: ' + data); });
    databench_process.on('exit', function (code) {
        databench_process_return_code = code;
        console.log('databench process exited with code ' + code);
    });
    before(function (done) {
        setTimeout(function () {
            chai_1.expect(databench_process_return_code).to.equal(-42);
            done();
        }, 2000);
    });
    after(function (done) {
        setTimeout(function () {
            databench_process.kill('SIGINT');
            done();
        }, 2000);
    });
    describe('App test', function () {
        it('has a working page', function (done) {
            request.get('http://localhost:5002', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('can serve a custom static location', function (done) {
            request.get('http://localhost:5002/special/analysis.js', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('serves all files from the same directory', function (done) {
            request.get('http://localhost:5002/static/analysis.js', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(404);
                done();
            });
        });
    });
});
describe('Server Process', function () {
    var databench_process_return_code = -42;
    var databench_process = child_process.spawn('databench', [
        '--log', 'WARNING',
        '--analyses', 'databench.tests.analyses',
        '--coverage', '.coverage.js',
        '--ssl-port', '5001',
        '--some-test-flag',
    ]);
    databench_process.stdout.on('data', function (data) { return console.log('databench stdout: ' + data); });
    databench_process.stderr.on('data', function (data) { return console.log('databench stderr: ' + data); });
    databench_process.on('exit', function (code) {
        databench_process_return_code = code;
        console.log('databench process exited with code ' + code);
    });
    before(function (done) {
        setTimeout(function () {
            chai_1.expect(databench_process_return_code).to.equal(-42);
            done();
        }, 2000);
    });
    after(function (done) {
        setTimeout(function () {
            databench_process.kill('SIGINT');
            done();
        }, 2000);
    });
    describe('App test', function () {
        it('has a working index page', function (done) {
            request.get('http://localhost:5000', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('has a working analysis page', function (done) {
            request.get('http://localhost:5000/parameters/', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('has a working index page with SSL', function (done) {
            request.get({ url: 'https://localhost:5001', rejectUnauthorized: false }, function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('has an invalid SSL certificate', function (done) {
            request.get('https://localhost:5001', function (error, response, body) {
                chai_1.expect(error.code).to.equal('DEPTH_ZERO_SELF_SIGNED_CERT');
                done();
            });
        });
        it('can access the static folder', function (done) {
            request.get('http://localhost:5000/static/test_file.txt', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                chai_1.expect(body).to.contain('placeholder');
                done();
            });
        });
        it('can access the node_modules folder', function (done) {
            request.get('http://localhost:5000/node_modules/test_file.txt', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                chai_1.expect(body).to.contain('placeholder');
                done();
            });
        });
    });
    describe('Routes Tests', function () {
        it('creates good routes for GET', function (done) {
            request.get('http://localhost:5000/simple2/get', function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                done();
            });
        });
        it('creates good routes for POST', function (done) {
            request.post({ url: 'http://localhost:5000/simple2/post', form: { data: 'test data' } }, function (error, response, body) {
                chai_1.expect(response.statusCode).to.equal(200);
                chai_1.expect(body).to.equal('test data');
                done();
            });
        });
    });
    describe('Echo Tests', function () {
        var c = new Databench.Connection();
        beforeEach(function () { c.disconnect(); c = Databench.connect('ws://localhost:5000/parameters/ws'); });
        after(function () { return c.disconnect(); });
        it('creates a WebSocket connection', function () {
            chai_1.expect(typeof c).to.equal('object');
        });
        it('sends an action without message', function (done) {
            c.on('test_action_ack', function () { return done(); });
            c.emit('test_action');
        });
        it('echos an object', function (done) {
            c.on('test_fn', function (data) {
                chai_1.expect(data).to.deep.equal([1, 2]);
                done();
            });
            c.emit('test_fn', [1, 2]);
        });
        it('echos an empty string', function (done) {
            c.on('test_fn', function (dataEmpty) {
                chai_1.expect(dataEmpty).to.deep.equal(['', 100]);
                done();
            });
            c.emit('test_fn', '');
        });
        it('echos a null parameter', function (done) {
            c.on('test_fn', function (dataNull) {
                chai_1.expect(dataNull).to.deep.equal([null, 100]);
                done();
            });
            c.emit('test_fn', null);
        });
    });
    describe('Command Line and Request Arguments', function () {
        describe('empty request args', function () {
            var c = new Databench.Connection('ws://localhost:5000/requestargs/ws');
            after(function () { return c.disconnect(); });
            it('valid empty request args', function (done) {
                c.on('echo_request_args', function (request_args) {
                    chai_1.expect(request_args).to.deep.equal({});
                    done();
                });
                c.connect();
            });
        });
        describe('simple request args', function () {
            var c = new Databench.Connection('ws://localhost:5000/requestargs/ws', '?data=requestargtest');
            after(function () { return c.disconnect(); });
            it('can access request args', function (done) {
                c.on('echo_request_args', function (request_args) {
                    chai_1.expect(request_args).to.deep.equal({ data: ['requestargtest'] });
                    done();
                });
                c.connect();
            });
        });
        describe('simple cli args', function () {
            var c = new Databench.Connection('ws://localhost:5000/cliargs/ws');
            after(function () { return c.disconnect(); });
            it('can access cli args', function (done) {
                c.on({ data: 'cli_args' }, function (args) {
                    chai_1.expect(args).to.deep.equal(['--some-test-flag']);
                    done();
                });
                c.connect();
            });
        });
    });
    describe('Cycle Connection', function () {
        var c = new Databench.Connection();
        before(function () { c = Databench.connect('ws://localhost:5000/requestargs/ws'); });
        after(function () { return c.disconnect(); });
        it('reconnects after disconnect', function (done) {
            c.disconnect();
            c.on('echo_request_args', function () { return done(); });
            c.connect();
        });
    });
    describe('Connection Interruption', function () {
        it('keeps analysis id', function () { return __awaiter(_this, void 0, void 0, function () {
            var client1, id1, client2, id2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Databench.attach('ws://localhost:5000/connection_interruption/ws')];
                    case 1:
                        client1 = _a.sent();
                        id1 = client1.analysisId;
                        client1.disconnect();
                        chai_1.expect(id1).to.have.length(8);
                        return [4 /*yield*/, Databench.attach('ws://localhost:5000/connection_interruption/ws', undefined, id1)];
                    case 2:
                        client2 = _a.sent();
                        id2 = client2.analysisId;
                        client2.disconnect();
                        chai_1.expect(id2).to.equal(id1);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Analysis Test', function () {
        var c = new Databench.Connection();
        beforeEach(function () { c.disconnect(); c = new Databench.Connection(); });
        after(function () { return c.disconnect(); });
        it('can open a connection without connecting', function (done) {
            c.preEmit('test', function (message) { return done(); });
            c.emit('test');
        });
        it('can emulate an empty backend response', function (done) {
            c.on('received', function (message) { return done(); });
            c.preEmit('test', function (message) { return c.trigger('received'); });
            c.emit('test');
        });
        it('can emulate a string backend response', function () {
            c.on('received', function (message) {
                chai_1.expect(message).to.equal('test message');
            });
            c.preEmit('test', function (message) { return c.trigger('received', 'test message'); });
            c.emit('test');
        });
    });
    ['parameters', 'parameters_py'].forEach(function (analysis) {
        describe("Parameter Tests for " + analysis, function () {
            var databench = new Databench.Connection();
            beforeEach(function () { databench.disconnect(); databench = Databench.connect("ws://localhost:5000/" + analysis + "/ws"); });
            after(function () { return databench.disconnect(); });
            it('calls an action without parameter', function (done) {
                databench.on('test_action_ack', function () { return done(); });
                databench.emit('test_action');
            });
            it('calls an action with an empty string', function (done) {
                databench.on('test_fn', function (data) {
                    chai_1.expect(data).to.deep.equal(['', 100]);
                    done();
                });
                databench.emit('test_fn', '');
            });
            it('calls an action with a single int', function (done) {
                databench.on('test_fn', function (data) {
                    chai_1.expect(data).to.deep.equal([1, 100]);
                    done();
                });
                databench.emit('test_fn', 1);
            });
            it('calls an action with a list', function (done) {
                databench.on('test_fn', function (data) {
                    chai_1.expect(data).to.deep.equal([1, 2]);
                    done();
                });
                databench.emit('test_fn', [1, 2]);
            });
            it('calls an action with a dictionary', function (done) {
                databench.on('test_fn', function (data) {
                    chai_1.expect(data).to.deep.equal([1, 2]);
                    done();
                });
                databench.emit('test_fn', { first_param: 1, second_param: 2 });
            });
            it('calls an action that sets state', function (done) {
                databench.on({ data: 'light' }, function (data) {
                    chai_1.expect(data).to.equal('red');
                    done();
                });
                databench.emit('test_state', ['light', 'red']);
            });
            it('calls an action that sets state', function (done) {
                databench.on({ data: 'light' }, function (data) {
                    chai_1.expect(data).to.equal('red');
                    done();
                });
                databench.emit('test_set_data', ['light', 'red']);
            });
            it('calls an action that sets class data', function (done) {
                databench.on({ class_data: 'light' }, function (data) {
                    chai_1.expect(data).to.equal('red');
                    done();
                });
                databench.emit('test_class_data', ['light', 'red']);
            });
            it('calls an action that well emit process states', function (done) {
                databench.on('test_fn', function (data) { return chai_1.expect(data).to.deep.equal([1, 100]); });
                databench.onProcess(123, function (data) {
                    chai_1.expect(data).to.be.oneOf(['start', 'end']);
                    if (data === 'end')
                        done();
                });
                databench.emit('test_fn', { first_param: 1, __process_id: 123 });
            });
            it('creates multiple connections', function () { return __awaiter(_this, void 0, void 0, function () {
                var connections, responses;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Promise.all([1, 2, 3, 4].map(function () { return Databench.attach("ws://localhost:5000/" + analysis + "/ws"); }))];
                        case 1:
                            connections = _a.sent();
                            // connection established, now check analysis id
                            connections.forEach(function (connection) { return chai_1.expect(connection.analysisId).to.have.length(8); });
                            responses = connections.map(function (connection) { return connection.once('test_action_ack'); });
                            // execute an actions that will trigger a responses
                            connections.forEach(function (connection) { return connection.emit('test_action'); });
                            return [4 /*yield*/, Promise.all(responses)];
                        case 2:
                            _a.sent();
                            connections.forEach(function (connection) { return connection.disconnect(); });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
//# sourceMappingURL=test.js.map